<?php
/**
 * class.authview.php
 *
 * PHP versions 5
 *
 * @author     M.Takai <JBC00205@nifty.com>
 * @copyright  2010 The Author
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 */

require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.error.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.errordlg.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.view.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.movepage.php';

// ǧںѤߥ桼VIewδܥ饹
class MobAuthView extends MobBaseView{

static function factory($t){
        return new self($t);
}

// Ƚ
protected function layoutLogout($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.logout.php';

	$logout = new modelLogout($this);
	$this->addLayout($logout->modelResponseBlock()); 
	throw new MobMovePage(MBAPP_URL . '/index.php?ssid=' . SESSION_ID);
	return true;
}

// μֹϿ
protected function layoutUinSet($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.uinset.php';

	if(MOB_CARRIER == 'pc'){
		throw new Exception('Error!');
	}
	$uin = new modelUinSet($this);
	try{
		$this->addLayout($uin->modelResponseBlock());
	}
	catch(Exception $e){
		$this->clearLayout();
		$dlg = new modelErrorDlg($this);
		$this->addLayout($dlg->modelResponseBlock($e->getMessage())); 
		return true;
	}
	throw new MobMovePage(MBAPP_URL . '/index.php?ssid=' . SESSION_ID);
	return true;

}

// μֹ
protected function layoutUinDel($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.uindel.php';

	$uin = new modelUinDel($this);
	try{
		$this->addLayout($uin->modelResponseBlock());
	}
	catch(Exception $e){
		$this->clearLayout();
		$dlg = new modelErrorDlg($this);
		$this->addLayout($dlg->modelResponseBlock($e->getMessage())); 
		return true;
	}
	throw new MobMovePage(MBAPP_URL . '/index.php?ssid=' . SESSION_ID);
	return true;

}
// ץեԽ
protected function layoutModifyProfileEntry($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userprofilecheck.php';

	// ϥåΥ顼ɽ
	if($err){
		$this->clearLayout();
		$error = new modelError($this);
		$this->addLayout($error->modelResponseBlock($err));
	}

	$regist = new modelUserProfileCheck($this);
	$this->addLayout($regist->modelRequestBlock());
	return true;
}

// 桼Ƴǧ̤ɽ
protected function layoutDeleteUserCheck($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userdelete.php';

	// Ƥå
	$check = new modelUserDelete($this);
	try{
		$this->addLayout($check->modelRequestBlock($this->request['id']));
	}
	catch(Exception $e){

		// 顼ɽ
		$this->clearLayout();
		return $this->layoutModifyProfileEntry($e->getMessage());
	}

	return true;
}

// 桼
protected function layoutDeleteUser($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userdelete.php';

	$delete = new modelUserDelete($this);
	$this->addLayout($delete->modelResponseBlock(USER_ID));
	throw new MobMovePage(MBAPP_URL . '/index.php');
	return true;
}

// ץեϿƳǧ̤ɽ
protected function layoutModifyProfileCheck($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userprofilecheck.php';

	// Ƥå
	$check = new modelUserProfileCheck($this);
	try{
		$this->addLayout($check->modelResponseBlock());
	}
	catch(Exception $e){
		return $this->layoutModifyProfileEntry($e->getMessage());
	}

	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userprofile.php';
	$regist = new modelUserProfile($this,$err);
	$this->addLayout($regist->modelRequestBlock());
	return true;
}

// ץեϿ
protected function layoutModifyProfile($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userprofile.php';

	$regist = new modelUserProfile($this);
	$this->addLayout($regist->modelResponseBlock(USER_ID));
	throw new MobMovePage(MBAPP_URL . '/index.php?ssid=' . SESSION_ID);
	return true;

}

// ץեϿ
protected function layoutProfileView($err=false){

	$this->contenttype='text/html';
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.profileview.php';

	$regist = new modelProfileView($this);
	$this->addLayout($regist->modelResponseBlock());
	$this->addLayout($regist->modelResponseNaviBlock());
	return true;
}

// ̥饤֥ͭβ̤ܤ륳ȥ
function controller(){
	
	// ̤ν
	try{
		switch($this->commonaction){
			case 'uinset':
				return $this->layoutUinSet();
				break;
			case 'uindel':
				return $this->layoutUinDel();
				break;
			case 'deletecheck':
				return $this->layoutDeleteUserCheck();
				break;
			case 'delete':
				return $this->layoutDeleteUser();
				break;
			case 'logout':	
				return $this->layoutLogout();
				break ;
			case 'profileentry':	
				return $this->layoutModifyProfileEntry();
				break;
			case 'profilecheck':	
				return $this->layoutModifyProfileCheck();
				break;
			case 'profile':
				return $this->layoutModifyProfile();
				break;
			case 'profileview':
				return $this->layoutProfileView();
				break;
			default:
				break;
		}
	}
        catch(MobMovePage $e){
		header('Location: ' . $e->getMessage());
                exit;
        }

	return false;

}

}
?>
