<?php
/**
 * PHP versions 5
 *
 * @author     M.Takai <JBC00205@nifty.com>
 * @copyright  2010 The Author
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 */

abstract class BaseEmojiConvert{

// ꥢ
const CarrierDOCOMO = 'docomo';
const CarrierAU = 'au';
const CarrierSOFTBANK = 'softbank';
const CarrierPC = 'pc';

// 󥳡ǥ
protected $internal_encoding;

// ֤줿ǥ쥯ȥURL
protected $image_url;

// ʸɤбѴ
abstract public function getInfoFromPictorialCharTable($c);

// ԤΥꥢ֤
abstract public function getCarrier();

// 󥹥ȥ饯
function __construct($encode,$imgurl){
	$this->internal_encoding = $encode;
	$this->image_url = $imgurl;

}

// ʸ饭ꥢ
public function getInfoFromChar($c){
	$code = 0x0000;
	if(!is_numeric($c)){

		// Хξ
		$lst = unpack('C*',$c);
		if(count($lst) == 2){
			$code =  ($lst[1] << 8) + $lst[2];
		}
	}
	else{
		// ͤξ
		$code = intVal($c);
	}

	// եȥХ󥯰ʳϥեJISѴ
	if($code < 0xF000){
		require_once dirname(__FILE__) . '/class.utos.php';
		if(isset(EmojiUToSJISConvertTable::$convert_table[$code])){
			$code = EmojiUToSJISConvertTable::$convert_table[$code];
		}

	}

	// ꥢ
	$tbl = $this->getInfoFromPictorialCharTable($code);

	return $tbl;
}

// ϥեफƤ
public function convertFromInputForm($s){
	
	// ɥAUΤUTF-8Ѵ
	if($this->getCarrier()  != self::CarrierSOFTBANK){
		$s = mb_convert_encoding($s,'UTF-8','SJIS-win');
	}

        $s = preg_replace_callback('/&#([x1-9][a-fA-F0-9]{4});|([\xEE][\x80-\xBF][\x80-\xBF])/',Array($this,'convertFromInputFormCallback'),$s);

        // ɤ᤹
        $s = mb_convert_encoding($s,$this->internal_encoding,'UTF-8');

        // ʳʸ򤲤Ѵƥ꥿
        return str_replace("&#x0000;",'',$s);
}


// 16HTMLƥƥѴ
public function convertFromInputFormCallback($match){

	if(!isset($match[2])){
		// HTMLƥƥɤͤѴ
		if(substr($match[1],0,1) == 'x'){
			// #&xXXXX;ξ
			$code = hexdec(substr($match[1],1,4));
		}
		else{
			// #&DDDDD;ξ
			$code = intVal($match[1]);
		}
	}
	else if($this->getCarrier() == self::CarrierSOFTBANK){

		// ꥢեȥХ󥯤ξ硢ʸUTF-1616ʥɤѴ
		$code = unpack('C*',mb_convert_encoding($match[0],'UTF-16','UTF-8'));
		$code = $code[1] * 256 + $code[2];
	}
	else{
		// ꥢDOCOMOAUξ硢ʸSJISɤ᤹
		$code = unpack('C*',mb_convert_encoding($match[0],'SJIS-win','UTF-8'));
		$code = $code[1] * 256 + $code[2];
	}

	// ɾμ

	$info = $this->getInfoFromChar($code);

	// ʸå
	if(isset($info['carrier'])){ 
		$code = $info['code'];
		$s =  sprintf('&#x%04X;',$code);
		return $s;
	}

	// ˡHTMLƥƥѴ
	return '&#x0000;';
}


// DBơ֥¸Ѥ&#xXXXXγʸ򰵽̤ 
public function convertToDB($s){
	$s =  str_replace('&amp;','&',$s);
	return preg_replace_callback('/&#x([EF][0-9A-F]{3});/',Array($this,'convertToDBCallback'),$s);
}

// ʸѤΥХåؿ
public function convertToDBCallback($a){
	$code = hexdec($a[1]);
	return pack('C3',0x1b,$code >> 8,$code &0xFF);
	
}

// ϥե˽ϤƤ
public function convertToInputForm($s){
	$s =  str_replace('&amp;','&',$s);
	$s =  preg_replace_callback('/\x1B([\xE0-\xFF][\x00-\xFF])|&#x([EF][0-9A-F]{3});/',Array($this,'convertToInputFormCallback'),$s);
	$s = $this->outputInputFormEscape($s);
	return $s;
}

// ϥե˽ϤƤ򥨥פ
private function outputInputFormEscape($s){
	$s = str_replace(
		Array(' ','<','>',"'","\"","\n"),
		Array('&nbsp;','&lt;','&gt;','&quot;','&#039;','&#010;'),$s
	);
	return $s;
}

// бꥢ&#xXXXX;ˤʳ&#DDDDD;Ѵ
public function convertToInputFormCallback($a){
	$code = 0;
	if(isset($a[2])){
		$code = hexdec($a[2]);
	}
	else if(isset($a[1])){
		$org = $a[1];
		$lst = unpack('C*',$org);
		$code = ($lst[1] * 256)+$lst[2];
	}

	$tbl = $this->getInfoFromChar($code);

	// 볨ʸɤơ֥ˤʤ
	if(!isset($tbl['code'])){
		return '&#x0000;';
	}

	$code = $tbl["code"];

	// ꥢƱʤΤ&#xXXXX;Ѵ
	if($tbl['carrier'] == $this->getCarrier()){
		return sprintf('&#x%04X;',$code);
	}

	// ꥢ㤤ʤΤ&#DDDDD;Ѵ

	return sprintf('&#%d;',$code);
	
}

// ƥɽѤ˽ϤƤ
public function convertToText($s){

	$s =  str_replace('&amp;','&',$s);

	// DB
	$s =  preg_replace_callback('/\x1B([\xE0-\xFF][\x00-\xFF])/',Array($this,'convertToTextCallback'),$s);

	// ׽
	$s = $this->outputTextEscape($s);

	return $s;
}

// ƥɽѤüʸ򥨥פ
private function outputTextEscape($s){
	$s = str_replace(
		Array(' ','<','>',"'","\"","\n"),
		Array('&nbsp;','&lt;','&gt;','&quot;','&#039;','<br>'),$s
	);
	return $s;
}

// ƥȽѥХåؿ
public function convertToTextCallback($a){
	$code = 0;
	if(isset($a[1])){
		$org = $a[1];
		$lst = unpack('C*',$org);
		$code = ($lst[1] * 256)+$lst[2];
	}

	// ʸɤˤĤƤξ
	$tbl = $this->getInfoFromChar($code);

	// 볨ʸɤơ֥¸ߤ
	if(isset($tbl['code'])){
		$code = $tbl['code'];
		$ent = sprintf('&#x%04X;',$code);
		return $ent;
	}
	// 볨ʸɤơ֥ˤʤ
	return '&#x0000;';

}

// ڡΤѴƽ
public function outputAll($s){

	// ϥ󥳡ǥ󥰤Ѵ
	$s = mb_convert_encoding($s,OUTPUT_ENCODING,$this->internal_encoding);
	header('Content-Type:text/html; charset=' . OUTPUT_CHARSET);
	
	// פʲԤ
	$s = str_replace("\n",'',$s);
	$s = preg_replace('/[\s]+/', ' ',$s);

	// ϥեβԤ򸵤᤹
	$s = str_replace('&#010;',"\n",$s);

	// ʸǽŪѴ
	$s = preg_replace_callback('/&#x([EF][0-9A-F]{3})\;|&#([1-9][0-9]{4})\;/',Array($this,'outputAllCallback'),$s);
	echo $s;
}
public function outputAllCallback($a){

	// &#DDDDD;&#xXXXX;Ѵ
	if(isset($a[2])){
		require_once dirname(__FILE__) . '/class.stou.php';
		$code = $a[2];
		if(isset(EmojiSJISToUConvertTable::$convert_table[$code])){
			$code = EmojiSJISToUConvertTable::$convert_table[$code];
		}
		$s= sprintf('&amp;#x%04X;',$code);
		return $s;
	}
	
	// &#xXXXX;ϥơ֥å
	$code = hexdec($a[1]);
	$info = $this->getInfoFromChar($code);

	// ơ֥󤬤ʤϢ֤
	$carrier = $this->getCarrier();
	if(!isset($info['code'])){
		return mb_convert_encoding('',OUTPUT_ENCODING,$this->internal_encoding);
	}

	// ꥢפ
	if($carrier == $info['carrier']){
		$s =  pack('C2', $code >> 8,$code & 0xFF);

		// եȥХ󥯤ξUTF-8Ѵ
		if($carrier == self::CarrierSOFTBANK){
			$s =  mb_convert_encoding($s,'UTF-8','UTF-16');
		}
		return $s;
	}

	// إɤϤ
	if($info['dst'] != 0x0000){
		$code = $info["dst"];
		$s =  pack('C2', $code >> 8,$code & 0xFF);

		// եȥХ󥯤ξUTF-8Ѵ
		if($carrier == self::CarrierSOFTBANK){
			$s = mb_convert_encoding($s,'UTF-8','UTF-16');
		}
		return $s;
	}


	// ᡼URL
	$img = $info['image'];
	$url = $this->image_url . '/' . $img ;

	// DOCOMOGIFʳPNG
	if($this->getCarrier() == self::CarrierDOCOMO || $this->getCarrier() == self::CarrierPC){
		$url = $url . '.gif';
	}
	else{
		$url = $url . '.png';
	}

	return sprintf("<img src='%s' >",$url);
}

// hidden˽ϤƤBASE64Ѵ
public function convertToHiddenTag($s){
	return base64_encode($s);
}
// hidden褿Ƥǥɤ
public function convertFromHiddenTag($s){
	$s =  base64_decode($s);
	$s = str_replace('&','&amp;',$s);
	return $s;
}
}
?>
