<?php
/**
 *
 * @author     M.Takai <JBC00205@nifty.com>
 * @copyright  2010 The Author
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 */

require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.view.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.error.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.movepage.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.errordlg.php';

// ȥ桼Controllerδܥ饹
class MobGuestView extends MobBaseView{

static function factory($t){
        return new self($t);
}


// ̤ɽ
protected function layoutLoginEntry($err=false){

	$this->contenttype = 'text/html';

	// 󥨥顼ɽ
	if($err){
		$error = new modelError($this);
		$this->addLayout($error->modelResponseBlock($err));
	}

	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.login.php';
	$login = new modelLogin($this,$err);
	$this->addLayout($login->modelRequestBlock()); 
	return true;
}

// ֹǧ
protected function layoutUinLogin($err=false){

	$this->contenttype = 'text/html';

	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.uinlogin.php';
	$login = new modelUinLogin($this);
	try{
		if(MOB_CARRIER == 'pc'){
			throw new Exception('Error!');
		}
		$this->addLayout($login->modelResponseBlock()); 
	}
	catch(Exception $e){
		$error = new modelErrorDlg($this);
		$this->addLayout($error->modelResponseBlock($e->getMessage()));
		return true;
	}
	throw new MobMovePage(MBAPP_URL  . 'index.php?op=list&ssid=' . SESSION_ID);  
	return true;
}

// 
protected function layoutLogin($err=false){

	$this->contenttype = 'text/html';

	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.login.php';
	$login = new modelLogin($this);
	try{

		$this->addLayout($login->modelResponseBlock()); 
	}
	catch(Exception $e){
		return $this->layoutLoginEntry($e->getMessage());
	}
	throw new MobMovePage(MBAPP_URL  . 'index.php?op=list&ssid=' . SESSION_ID);  
	return true;
}

// 桼Ͽ̤ɽ
protected function layoutRegistEntry($err=false){

	$this->contenttype = 'text/html';

	if($err){
		$error = new modelError($this);
		$this->addLayout($error->modelResponseBlock($err));
	}

	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userregistcheck.php';
	$regist = new modelRegistCheck($this,$err);
	$this->addLayout($regist->modelRequestBlock());
	return true;
}

// 桼ϿƳǧ̤ɽ
protected function layoutRegistCheck($err=false){

	$this->contenttype = 'text/html';

	// Ƥǧ֥å쥤Ȥ
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userregistcheck.php';
	$check = new modelRegistCheck($this);
	try{
		$this->addLayout($check->modelResponseBlock());
	}
	catch(Exception $e){
		return $this->layoutRegistEntry($e->getMessage());
	}

	// Ͽեɽ
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userregist.php';
	$regist = new modelRegist($this,$err);
	$this->addLayout($regist->modelRequestBlock());
	return true;
}

// 桼Ͽ
protected function layoutRegist($err=false){

	$this->contenttype = 'text/html';

        require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userregist.php';

        $this->contenttype='text/html';
        $regist = new modelRegist($this);
        try{
                $this->addLayout($regist->modelResponseBlock());
        }
        catch(Exception $e){
                $error = new modelErrorDlg($this);
                $this->addLayout($error->modelResponseBlock($e->getMessage()));
        }
        return true;

}

// 桼Ͽδλ
protected function layoutApprove($err=false){

	$this->contenttype = 'text/html';

	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.approve.php';
	$approve = new modelApprove($this);
	try{
		$this->addLayout($approve->modelResponseBlock());
	}
	catch(Exception $e){
		$error = new modelErrorDlg($this);
		$this->addLayout($error->modelResponseBlock($e->getMessage()));
	}
	return true;
}

// ץեϿ
protected function layoutProfileView($err=false){

	$this->contenttype = 'text/html';

        require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.profileview.php';

        $regist = new modelProfileView($this);
        $this->addLayout($regist->modelResponseBlock());
        $this->addLayout($regist->modelResponseNaviBlock());
        return true;
}

// ̥饤֥ͭβ̤ܤ륳ȥ
function controller(){
	try{
		switch($this->commonaction){
			case 'loginentry':	
				return $this->layoutLoginEntry();
				break;
			case 'uinlogin':	
				return $this->layoutUinLogin();
				break;
			case 'login':	
				return $this->layoutLogin();
				break;
			case 'registentry':	
				return $this->layoutRegistEntry();
				break;
			case 'registcheck':	
				return $this->layoutRegistCheck();
				break;
			case 'regist':
				return $this->layoutRegist();
				break;
			case 'approve':
				return $this->layoutApprove();
				break;
			case 'profileview':
				return $this->layoutProfileView();
				break;
			default:
				break;
		}
	}
	catch(MobMovePage $e){
		header('Location: ' . $e->getMessage());
		exit;
	}
	return false;

}

}
?>
