<?php
/**
 * class.view.php
 *
 * PHP versions 5
 *
 * @author     M.Takai <JBC00205@nifty.com>
 * @copyright  2010 The Author
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 */

require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.view.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.model.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.errordlg.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.error.php';

class MobBBSView extends MobBaseView{

// Factory᥽å
public static function factory($t){
	return new self($t);
}

// ʸɽ쥤ȥ᥽å
private function layoutContentView($err=false){

	// ɬפʥ󥯥롼ɥեɤ߹
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscontent.php';

	$this->clearLayout();

	// ʸɽ
	$bbs = new modelBBSContent($this,$err);
	try{
		$this->addLayout($bbs->modelResponseBlock());
	}
	catch(Exception $e){

		// ɽ˼
		$this->layoutContentList($e->getMessage());
		return;
	}


	// ʥӤդ
	$this->addLayout($bbs->modelResponseNaviBlock());

}

// Ƥ줿ǧ᥽å
private function layoutContentCheck($err=false){

	// ɬפʥ󥯥롼ɥեɤ߹
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscheck.php';
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbssave.php';

	$this->clearLayout();

	// ǧ̤ɽ
	$bbs = new modelBBSCheck($this);
	try{
		$this->addLayout($bbs->modelResponseBlock());
	}
	catch(Exception $e){

		// ɽ˼
		return $this->layoutContentList($e->getMessage());
	}

	// ѥեɽ
	$form = new modelBBSSave($this);
	$this->addLayout($form->modelRequestBlock());

}

// Ƥ줿¸᥽å
private function layoutContentSave($err=false){

	// ɬפʥ󥯥롼ɥեɤ߹
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbssave.php';

	$this->clearLayout();

	// ¸λ̤ɽ
	$bbs = new modelBBSSave($this);
	$this->addLayout($bbs->modelResponseBlock());

}

// ɽ᥽å
private function layoutContentList($err=false){

	// ɬפʥ󥯥롼ɥեɤ߹
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscontent.php';
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbssave.php';
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscheck.php';

	$this->clearLayout();

	// 顼åɽ
	if($err){
		$bbs = new modelError($this);
		$this->addLayout($bbs->modelResponseBlock($err));
	}

	// ɽ
	$bbs = new modelBBSContent($this);
	try{
		$this->addLayout($bbs->modelRequestBlock());
	}
	catch(Exception $e){

		// ɽ˼
		$bbs = new modelError($this);
		$this->addLayout($bbs->modelResponseBlock('ɽǤ뵭ޤ'));
	}

	// ѥեɽ
	$form = new modelBBSCheck($this);
	$this->addLayout($form->modelRequestBlock());

	// ʥӤդ
	$this->addLayout($bbs->modelRequestNaviBlock());

	// åγ
	if(!defined('SESSION_ID') && !defined('SESSION_KEY')){
		$ses = new MobBaseSession(SESSION_TABLE);
		$ses->createSession();
		define('SESSION_ID',$ses->ssid);
 		define('SESSION_KEY',$ses->sskey);
	
	}

}

// ȥ᥽å
function controller(){
	$this->contenttype = 'text/html';
	switch($this->action){
		case 'view': // ʸɤ
			return $this->layoutContentView();
			break;
			
		case 'check': // Ƥ줿ǧ
			return $this->layoutContentCheck();
			break;

		case 'save': // Ƥ줿¸
			return $this->layoutContentSave();
			break;

		case 'list': // ɽ
		default:
			return $this->layoutContentList();
			break;
	}
}

}
?>
