<?php
/**
 * PHP versions 5
 *
 * @author     M.Takai <JBC00205@nifty.com>
 * @copyright  2010 The Author
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 */


require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.authview.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.model.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.error.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.errordlg.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.profileview.php';

class MobAuthBBS2View extends MobAuthView{

// Factor᥽å
public static function factory($t){
	return new self($t);
}
	
// ץեʸɽ
protected function layoutProfileBody($err=false){

	// ץեʸɽ
	$profile = new modelProfileView($this);
	$this->addLayout($profile->modelResponseBlock());
}

// ʸɽ᥽å
protected function layoutContentBody($err=false){

	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscontent.php';

	// ʸɽ
	$bbs = new modelBBS2Content($this);
	$this->addLayout($bbs->modelResponseBlock());

	// ʥӤդ
	$this->addLayout($bbs->modelResponseNaviBlock());
}

// Ƥ줿ǧ᥽å
protected function layoutContentCheck($err=false){
	// ǧ̤ɽ
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscheck.php';
	$bbs = new modelBBS2Check($this);
	try{
		$this->addLayout($bbs->modelResponseBlock());
	}
	catch(Exception $e){
		 return $this->layoutContentEntry($e->getMessage());
	}

	// ѥեɽ
	if(isset($this->request['id'])){
		require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbsupdate.php';
		$form = new modelBBS2Update($this);
		$this->addLayout($form->modelRequestBlock());
	}
	else{
		require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbssave.php';
		$form = new modelBBS2Save($this);
		$this->addLayout($form->modelRequestBlock());
	}

}

// κǧ᥽å
protected function layoutContentDeleteCheck($err=false){

	// ǧ̤ɽ
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbsdelete.php';
	$bbs = new modelBBS2Delete($this);
	$this->addLayout($bbs->modelRequestBlock());

}


// ᥽å
protected function layoutContentDelete($err=false){

	//  
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbsdelete.php';
	$bbs = new modelBBS2Delete($this);
	$this->addLayout($bbs->modelResponseBlock());

}

// Ƥ줿¸᥽å
protected function layoutContentPost($err=false){

	// ɽ
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbssave.php';
	$bbs = new modelBBS2Save($this);
	$this->addLayout($bbs->modelResponseBlock());

}

// Ƥ줿¸᥽å
protected function layoutContentUpdate($err=false){

	// ɽ
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbsupdate.php';
	$bbs = new modelBBS2Update($this);
	$this->addLayout($bbs->modelResponseBlock());

}
// ɽ᥽å
protected function layoutContentList($err=false){

	// 顼åɽ
	if($err){
		$bbs = new modelError($this);
		$this->addLayout($bbs->modelResponseBlock($err));
	}

	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.hello.php';

        // ֤褦XXפΥåФ
        if(!isset($this->request['page']) || intVal($this->request['page']) == 0)
	{
                $hello = new modelHello($this);
                $this->addLayout($hello->modelResponseBlock());
        }

	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscontent.php';
	$bbs = new modelBBS2Content($this);
	try{
		$this->addLayout($bbs->modelRequestBlock());
	}
	catch(Exception $e){

		// ɽ˼
		$bbs = new modelError($this);
		$this->addLayout($bbs->modelResponseBlock('ɽǤ뵭ޤ'));
	}

	// ʥӤդ
	$this->addLayout($bbs->modelRequestNaviBlock());

	// ѥեɽ
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbsentry.php';
	$form = new modelBBS2Entry($this);
	$this->addLayout($form->modelRequestBlock());

	// ϿԽܥɽ
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userprofileentry.php';
	$modify = new modelUserProfileEntry($this);
	$this->addLayout($modify->modelRequestBlock());

        // ǧڥܥɽ
        if(MOB_CARRIER != 'pc'){
                $uin = false;
                if(defined('UIN_REGISTERED')){
                        require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.uindel.php';
                        $uin = new modelUinDel($this);
                }
                else{
                        require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.uinset.php';
                        $uin = new modelUinSet($this);
                }
                $this->addLayout($uin->modelRequestBlock());
        }

	// ȥܥɽ
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.logout.php';
	$logout = new modelLogout($this);
	$this->addLayout($logout->modelRequestBlock());

}


// ϥڡɽ
protected function layoutContentEntry($err=false){
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscheck.php';
	if($err){
		$this->clearLayout();
		$bbs = new modelError($this);
		$this->addLayout($bbs->modelResponseBlock($err));
	}
	$form = new modelBBS2Check($this);
	$this->addLayout($form->modelRequestBlock());
}

// ȥ᥽å
function controller(){
	if(parent::controller()){
		return true;
	}
	$this->contenttype = 'text/html';
	try{
		switch($this->action){
			case 'profileview': // ץեɤ
				return $this->layoutProfileBody();
				break;
			case 'entry': // 
				return $this->layoutContentEntry();
				break;
				
			case 'view': // ʸɤ
				return $this->layoutContentBody();
				break;
				
			case 'check': // Ƥ줿ǧ
				return $this->layoutContentCheck();
				break;

			case 'deletecheck': // 뵭ǧ
				return $this->layoutContentDeleteCheck();
				break;

			case 'delete': // 
				return $this->layoutContentDelete();
				break;

			case 'save': // Ƥ줿¸
				return $this->layoutContentPost();
				break;

			case 'update': // Ƥ줿¸
				return $this->layoutContentUpdate();
				break;

			case 'list': // ɽ
			default:
				$this->action = 'list';
				return $this->layoutContentList();
				break;
		}
	}
	catch(Exception $e){
		$error = new modelErrorDlg($this);
		$this->clearLayout();
		$this->addLayout($error->modelResponseBlock($e->getMessage()));
	}

}

}
?>
