<?php
/**
 * PHP versions 5
 *
 * @author     M.Takai <JBC00205@nifty.com>
 * @copyright  2010 The Author
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 */


require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.guestview.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.model.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.error.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.errordlg.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.profileview.php';

class MobGuestBBS2View extends MobGuestView{

// Factory᥽å
public static function factory($t){
	return new self($t);
}

// ʸɽ᥽å
protected function layoutContentBody($err=false){

	$this->clearLayout();

	// ʸɽ
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscontent.php';
	$bbs = new modelBBS2Content($this);
	$this->addLayout($bbs->modelResponseBlock());


	// ʥӤդ
	$this->addLayout($bbs->modelResponseNaviBlock());

}

// ץեʸɽ
protected function layoutProfileBody($err=false){

	$this->clearLayout();

        // ץեʸɽ
        $profile = new modelProfileView($this);
	$this->addLayout($profile->modelResponseBlock());

}

// ɽ᥽å
protected function layoutContentList($err=false){

	$this->clearLayout();

	// 顼åɽ
	if($err){
		$bbs = new modelError($this);
		$this->addLayout($bbs->modelResponseBlock($err));
	}

        require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.hello.php';

        // ֤褦XXפΥåФ
        if(!isset($this->request['page']) || intVal($this->request['page']) == 0){
                $hello = new modelHello($this);
                $this->addLayout($hello->modelResponseBlock());
        }

	// ɽ
	require_once MBAPP_TRUST_PATH . APPNAME . '/class/class.bbscontent.php';
	$bbs = new modelBBS2Content($this);
	try{
		$this->addLayout($bbs->modelRequestBlock());
	}
	catch(Exception $e){

		// ɽ˼
		$bbs = new modelError($this);
		$this->addLayout($bbs->modelResponseBlock('ɽǤ뵭ޤ'));
	}


	// ʥӤդ
	$this->addLayout($bbs->modelRequestNaviBlock());

	// ܥɽ
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.loginentry.php';
	$login = new modelLoginEntry($this,$err);
	$this->addLayout($login->modelrequestBlock());

	// Ͽܥɽ
	require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userregistentry.php';
	$regist = new modelRegistEntry($this);
	$this->addLayout($regist->modelRequestBlock());

	// μֹܥɽ
	if(MOB_CARRIER != 'pc'){
		require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.uinlogin.php';
		$uin = new modelUinLogin($this);
		$this->addLayout($uin->modelRequestBlock());
	}
}

// ȥ᥽å
function controller(){
	if(parent::controller()){
		return true;
	}
        $this->contenttype = 'text/html';
        try{
		switch($this->action){
			
			case 'profileview': // ץեʸɤ
				return $this->layoutProfileBody();
				break;
			case 'view': // ʸɤ
				return $this->layoutContentBody();
				break;
			
			case 'list': // ɽ
			default:
				return $this->layoutContentList();
				break;
		}
	}
	catch(Exception $e){
		$error = new modelErrorDlg($this,$e->getMessage());
		$this->clearLayout();
		$this->addLayout($error->modelResponseBlock());
	}

	return Array();
}

}
?>
