<?php
/**
 * PHP versions 5
 *
 * @author     M.Takai <JBC00205@nifty.com>
 * @copyright  2010 The Author
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 */

require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.adminview.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.profileview.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.model.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.error.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.errordlg.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userprofileentry.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.userregistentry.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.logout.php';
require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.hello.php';

class MobAdminProfileView extends MobAdminView{

static function factory($t){
        return new self($t);
}

// ץեɽ
protected function layoutProfileList($err=false){


	$this->contenttype = 'text/html';

	// 顼åɽ
	if($err){
		$this->clearLayout();
		$bbs = new modelProfileError($this);
		$this->addLayout($bbs->modelResponseBlock($err));
	}

	// ֤褦XXפΥåФ
	if(!isset($this->request['page']) || intVal($this->request['page']) == 0){
		$hello = new modelHello($this);
		$this->addLayout($hello->modelResponseBlock());
	}

	// ץեɽ
	$profile = new modelProfileView($this,'op=view');
	try{
		$this->addLayout($profile->modelRequestBlock());
	}
	catch(Exception $e){

		// ɽ˼
		if(!$err){ 
			return $this->layoutProfileList($e->getMessage());
		}
	}

	// ʥӤդ
	$this->addLayout($profile->modelRequestNaviBlock());

	// ϿԽܥɽ
	$modify = new modelUserProfileEntry($this);
	$this->addLayout($modify->modelRequestBlock());

	// 桼Ͽܥɽ
	$regist = new modelRegistEntry($this);
        $this->addLayout($regist->modelRequestBlock());

        // ǧڥܥɽ
        if(MOB_CARRIER != 'pc'){
		$uin = false;
		if(defined('UIN_REGISTERED')){
			require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.uindel.php';
			$uin = new modelUinDel($this);
		}
		else{
			require_once MBAPP_TRUST_PATH . '/MobCommon/class/class.uinset.php';
			$uin = new modelUinSet($this);
		}
		$this->addLayout($uin->modelRequestBlock());
	}

	
	// ȥܥɽ
	$logout = new modelLogout($this);
	$this->addLayout($logout->modelRequestBlock());
}

// ץեʸɽ
protected function layoutProfileBody($err=false)
{
	$this->contenttype = 'text/html';
	if($this->request['ssid'] != SESSION_ID){
		throw new Exception('å󤬴ڤǤ');
	}

	$this->clearLayout();
	$profile = new modelProfileView($this);
	$this->addLayout($profile->modelResponseBlock());
	$this->addLayout($profile->modelResponseBlockNavi());

}

// ȥ᥽å
function controller(){

	if(parent::controller()){
		return true;
	}
	try{

		switch($this->action){
			case 'view': // ץեʸɤ
				return $this->layoutProfileBody();
				break;
	
			case 'list': // ץեɽ
			default:
				return $this->layoutProfileList();
				break;
		}
		return false;
	}
	catch(Exception $e){
		$this->contenttype = 'text/html';
                $error = new modelErrorDlg($this);
                $this->addLayout($error->modelResponseBlock($e->getMessage()));
        }
	return true;

}

}
?>
